diff -urN build.old/config.log build/config.log
--- build.old/config.log	2020-12-22 14:28:34.260422884 +1100
+++ build/config.log	2020-12-22 14:33:41.109817220 +1100
@@ -892,7 +892,7 @@
 configure:10083: result: yes
 configure:10104: checking for vasnprintf
 configure:10104: gcc -o conftest -g -O0 -Wformat=2   conftest.c  >&5
-/usr/bin/ld: /tmp/branden/ccpMYpna.o: in function `main':
+/usr/bin/ld: /tmp/branden/cc56i9Uy.o: in function `main':
 /home/branden/src/GIT/groff/build/conftest.c:76: undefined reference to `vasnprintf'
 collect2: error: ld returned 1 exit status
 configure:10104: $? = 1
@@ -986,7 +986,7 @@
 configure:10104: result: yes
 configure:10104: checking for __fseterr
 configure:10104: gcc -o conftest -g -O0 -Wformat=2   conftest.c  >&5
-/usr/bin/ld: /tmp/branden/cc82QMRn.o: in function `main':
+/usr/bin/ld: /tmp/branden/ccI9vmAC.o: in function `main':
 /home/branden/src/GIT/groff/build/conftest.c:77: undefined reference to `__fseterr'
 collect2: error: ld returned 1 exit status
 configure:10104: $? = 1
Binary files build.old/doc/groff.dvi and build/doc/groff.dvi differ
diff -urN build.old/doc/groff.dvi.t2d/doc!groff.t2d/dvi/build/groff.log build/doc/groff.dvi.t2d/doc!groff.t2d/dvi/build/groff.log
--- build.old/doc/groff.dvi.t2d/doc!groff.t2d/dvi/build/groff.log	2020-12-22 14:29:20.913865096 +1100
+++ build/doc/groff.dvi.t2d/doc!groff.t2d/dvi/build/groff.log	2020-12-22 14:34:23.003083473 +1100
@@ -1,4 +1,4 @@
-This is pdfTeX, Version 3.14159265-2.6-1.40.19 (TeX Live 2019/dev/Debian) (preloaded format=etex 2020.4.28)  22 DEC 2020 14:29
+This is pdfTeX, Version 3.14159265-2.6-1.40.19 (TeX Live 2019/dev/Debian) (preloaded format=etex 2020.4.28)  22 DEC 2020 14:34
 entering extended mode
  restricted \write18 enabled.
  file:line:error style messages enabled.
diff -urN build.old/doc/groff.dvi.t2d/doc!groff.t2d/dvi/check_recorder/openout.log build/doc/groff.dvi.t2d/doc!groff.t2d/dvi/check_recorder/openout.log
--- build.old/doc/groff.dvi.t2d/doc!groff.t2d/dvi/check_recorder/openout.log	2020-12-22 14:29:11.533575529 +1100
+++ build/doc/groff.dvi.t2d/doc!groff.t2d/dvi/check_recorder/openout.log	2020-12-22 14:34:15.954870702 +1100
@@ -1,4 +1,4 @@
-This is pdfTeX, Version 3.14159265-2.6-1.40.19 (TeX Live 2019/dev/Debian) (preloaded format=etex 2020.4.28)  22 DEC 2020 14:29
+This is pdfTeX, Version 3.14159265-2.6-1.40.19 (TeX Live 2019/dev/Debian) (preloaded format=etex 2020.4.28)  22 DEC 2020 14:34
 entering extended mode
  restricted \write18 enabled.
  file:line:error style messages enabled.
diff -urN build.old/doc/groff.pdf.t2p/doc!groff.t2d/pdf/build/groff.log build/doc/groff.pdf.t2p/doc!groff.t2d/pdf/build/groff.log
--- build.old/doc/groff.pdf.t2p/doc!groff.t2d/pdf/build/groff.log	2020-12-22 14:29:35.430312810 +1100
+++ build/doc/groff.pdf.t2p/doc!groff.t2d/pdf/build/groff.log	2020-12-22 14:34:32.207361170 +1100
@@ -1,4 +1,4 @@
-This is pdfTeX, Version 3.14159265-2.6-1.40.19 (TeX Live 2019/dev/Debian) (preloaded format=pdfetex 2020.4.28)  22 DEC 2020 14:29
+This is pdfTeX, Version 3.14159265-2.6-1.40.19 (TeX Live 2019/dev/Debian) (preloaded format=pdfetex 2020.4.28)  22 DEC 2020 14:34
 entering extended mode
  restricted \write18 enabled.
  file:line:error style messages enabled.
diff -urN build.old/doc/groff.pdf.t2p/doc!groff.t2d/pdf/check_recorder/openout.log build/doc/groff.pdf.t2p/doc!groff.t2d/pdf/check_recorder/openout.log
--- build.old/doc/groff.pdf.t2p/doc!groff.t2d/pdf/check_recorder/openout.log	2020-12-22 14:29:21.077870157 +1100
+++ build/doc/groff.pdf.t2p/doc!groff.t2d/pdf/check_recorder/openout.log	2020-12-22 14:34:23.127087216 +1100
@@ -1,4 +1,4 @@
-This is pdfTeX, Version 3.14159265-2.6-1.40.19 (TeX Live 2019/dev/Debian) (preloaded format=pdfetex 2020.4.28)  22 DEC 2020 14:29
+This is pdfTeX, Version 3.14159265-2.6-1.40.19 (TeX Live 2019/dev/Debian) (preloaded format=pdfetex 2020.4.28)  22 DEC 2020 14:34
 entering extended mode
  restricted \write18 enabled.
  file:line:error style messages enabled.
Binary files build.old/groff-1.23.0.rc1.82-3c6d.tar.gz and build/groff-1.23.0.rc1.82-3c6d.tar.gz differ
diff -urN build.old/src/roff/groff/tests/string_case_xform_unicode_escape.sh.log build/src/roff/groff/tests/string_case_xform_unicode_escape.sh.log
--- build.old/src/roff/groff/tests/string_case_xform_unicode_escape.sh.log	2020-12-22 14:29:08.149471013 +1100
+++ build/src/roff/groff/tests/string_case_xform_unicode_escape.sh.log	2020-12-22 14:34:12.582768867 +1100
@@ -1,5 +1,5 @@
---- /dev/fd/63	2020-12-22 14:29:08.145470889 +1100
-+++ /dev/fd/62	2020-12-22 14:29:08.145470889 +1100
+--- /dev/fd/63	2020-12-22 14:34:12.582768867 +1100
++++ /dev/fd/62	2020-12-22 14:34:12.582768867 +1100
 @@ -1 +1,3 @@
 -attaché ATTACHÉ
 +troff: backtrace: '<standard input>':4: string 'attache'
diff -urN build.old/test-suite.log build/test-suite.log
--- build.old/test-suite.log	2020-12-22 14:29:09.017497824 +1100
+++ build/test-suite.log	2020-12-22 14:34:13.454795205 +1100
@@ -15,8 +15,8 @@
 XFAIL: src/roff/groff/tests/string_case_xform_unicode_escape.sh
 ===============================================================
 
---- /dev/fd/63	2020-12-22 14:29:08.145470889 +1100
-+++ /dev/fd/62	2020-12-22 14:29:08.145470889 +1100
+--- /dev/fd/63	2020-12-22 14:34:12.582768867 +1100
++++ /dev/fd/62	2020-12-22 14:34:12.582768867 +1100
 @@ -1 +1,3 @@
 -attaché ATTACHÉ
 +troff: backtrace: '<standard input>':4: string 'attache'